## postgis 3.3.2+dfsg

=== raster/Makefile ===
#############################################################################
#
# Master Makefile used to build WKT Raster
#
# Copyright (c) 2009 Sandro Santilli <strk@kbt.io>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#############################################################################

CC=gcc
CFLAGS=-I../liblwgeom -std=gnu99 -g -O2 -fno-math-errno -fno-signed-zeros -Wall
LDFLAGS =  -lm

all:    

corelib:
	$(MAKE) -C rt_core

pglib: corelib
	$(MAKE) -C rt_pg

rtloader: corelib
	$(MAKE) -C loader

rtpostgis.sql:
	$(MAKE) -C rt_pg rtpostgis.sql

install: all
	$(MAKE) -C rt_pg install
	$(MAKE) -C loader install
	$(MAKE) -C scripts install

uninstall:
	$(MAKE) -C rt_pg uninstall
	$(MAKE) -C loader uninstall
	$(MAKE) -C scripts uninstall

clean:
	$(MAKE) -C rt_core $@
	$(MAKE) -C rt_pg $@
	$(MAKE) -C loader $@
	$(MAKE) -C test $@
	$(MAKE) -C scripts $@

distclean: clean
	$(MAKE) -C rt_core $@
	$(MAKE) -C rt_pg $@
	$(MAKE) -C loader $@
	$(MAKE) -C test $@
	$(MAKE) -C scripts $@
	rm -f raster_config.h Makefile

check check-unit check-regress core-check:
	$(MAKE) -C test $@

=== extensions/postgis_raster/Makefile ===
include ./../upgradeable_versions.mk

EXTENSION     = postgis_raster
EXTVERSION    = 3.3.2
MINORVERSION  = 3.3
MODULEPATH    = $$libdir/$(EXTENSION)-3

ifeq (no,yes)
MODULEPATH=$$libdir/$(EXTENSION)-$(MINORVERSION)
endif
GREP = /bin/grep

# SQL preprocessor
SQLPP = /usr/bin/cpp -traditional-cpp -w -P

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | \
						$(PERL) -pe 's/\d.\d.(\d+)[a-zA-Z]*\d*/$1/'

PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        $(PERL) -pe 's/\d\.\d\.(.*)/\1/' | \
                        $(GREP) "[a-zA-Z]" | \
                        $(PERL) -pe 's/\d+[a-zA-Z]+(\d+)/\1/'

MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        $(PERL) -pe 's/\d\.\d\.(.*)/\1/' | \
                        $(GREP) "[a-zA-Z]" | \
                        $(PERL) -pe 's/(\d+[a-zA-Z]+)\d*/\1/'

DATA_built = \
	$(EXTENSION).control \
	sql/$(EXTENSION)--$(EXTVERSION).sql \
	sql/$(EXTENSION)--unpackaged.sql \
	sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql \
	$(NULL)

# Scripts making up the extension file
# NOTE: order matters
EXTENSION_SCRIPTS = \
	sql/rtpostgis.sql \
	sql/raster_comments.sql

# Scripts making up the extension minor upgrade file
# NOTE: order matters
EXTENSION_UPGRADE_SCRIPTS = \
	../postgis_extension_helper.sql \
	sql/rtpostgis_upgrade.sql \
	../../doc/raster_comments.sql \
	../postgis_extension_helper_uninstall.sql

# Scripts making up the extension upgrade-from-unpackaged file
# NOTE: order matters
EXTENSION_UNPACKAGED_UPGRADE_SCRIPTS = \
	sql/$(EXTENSION)--$(EXTVERSION).sql

EXTRA_CLEAN = sql

CURV_big=33

all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql

sql:
	mkdir -p $@

$(EXTENSION).control: $(EXTENSION).control.in Makefile
	cat $< \
		| sed -e 's|@EXTVERSION@|$(EXTVERSION)|g' \
		| sed -e 's|@EXTENSION@|$(EXTENSION)|g' \
		| sed -e 's|@MODULEPATH@|$(MODULEPATH)|g' \
		> $@

sql/$(EXTENSION)--$(EXTVERSION).sql: $(EXTENSION_SCRIPTS) | sql
	printf '\\echo Use "CREATE EXTENSION $(EXTENSION)" to load this file. \\quit\n' > $@
	cat $^ >> $@

sql/$(EXTENSION)--unpackaged.sql: Makefile | sql
	echo "-- Nothing to do here" > $@

sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: sql/$(EXTENSION)--ANY--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION).sql ../../utils/create_unpackaged.pl Makefile | sql
	cat sql/$(EXTENSION)--$(EXTVERSION).sql | $(PERL) ../../utils/create_unpackaged.pl $(EXTENSION) > $@
	# Upgrade after packaging
	cat sql/$(EXTENSION)--ANY--$(EXTVERSION).sql >> $@

unpackaged_check.sql: unpackaged_check.sql.in Makefile
	cat $< \
		| sed -e 's|@EXTVERSION@|$(EXTVERSION)|g' \
		> $@

#strip BEGIN/COMMIT since these are not allowed in extensions
sql/rtpostgis.sql: sql/rtpostgis_for_extension.sql | sql
	$(PERL) -pe 's/BEGIN\;//g ; s/COMMIT\;//g' $< > $@

sql/rtpostgis_for_extension.sql: ../../raster/rt_pg/rtpostgis.sql.in ../../postgis_revision.h | sql
	$(SQLPP) -I./../../postgis/ -I../../ $< | grep -v '^#' | \
	$(PERL) -lpe "s'MODULE_PATHNAME'\$(MODULEPATH)'g" > $@

sql/rtpostgis_upgrade.sql: sql/rtpostgis_upgrade_for_extension.sql | sql
	$(PERL) -pe "s/BEGIN\;//g ; s/COMMIT\;//g; s/^(DROP .*)\;/SELECT postgis_extension_drop_if_exists('$(EXTENSION)', '\1');\n\1\;/" $< > $@

#this keeps the @extschema@. in place since extension machinery will replace during install
sql/rtpostgis_upgrade_for_extension.sql: ../../raster/rt_pg/rtpostgis_upgrade_cleanup.sql sql/rtpostgis_upgrade_for_extension.sql.in ../../raster/rt_pg/rtpostgis_drop.sql | sql
	echo 'BEGIN;' > $@
	cat $^ | sed -e 's/^BEGIN;$$//' -e 's/^COMMIT;$$//' >> $@
	echo 'COMMIT;' >> $@


sql/rtpostgis_upgrade_for_extension.sql.in: sql/rtpostgis_for_extension.sql ../../utils/create_upgrade.pl | sql
	$(PERL) ../../utils/create_upgrade.pl $< > $@


../../doc/raster_comments.sql:
	$(MAKE) -C ../../doc comments

sql/raster_comments.sql: ../../doc/raster_comments.sql | sql
	cp $< $@

sql/$(EXTENSION)--ANY--$(EXTVERSION).sql: $(EXTENSION_UPGRADE_SCRIPTS) | sql
	printf '\\echo Use "CREATE EXTENSION $(EXTENSION)" to load this file. \\quit\n' > $@
	cat $^ >> $@

include ./../upgrade-paths-rules.mk

distclean: clean
	rm -f Makefile

PG_CONFIG := /var/lib/jenkins/workspace/pg/rel/pg11w64/bin/pg_config
PGXS := /var/lib/jenkins/workspace/pg/rel/pg11w64/lib/postgresql/pgxs/src/makefiles/pgxs.mk
include $(PGXS)
PERL = /usr/bin/perl

=== debian/changelog ===
postgis (3.3.2+dfsg-1ubuntu1) lunar; urgency=medium

  * Merge with Debian unstable (LP: #2001569). Remaining changes:
    - Disable LTO on ppc64el to fix build failure.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Wed, 04 Jan 2023 09:32:57 -0300

postgis (3.3.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 13 Nov 2022 09:03:35 +0100

postgis (3.3.1+dfsg-2ubuntu2) lunar; urgency=medium

  * No change rebuild for postgresql-15.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Fri, 23 Dec 2022 08:51:24 -0300

postgis (3.3.1+dfsg-2ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable LTO on ppc64el to fix build failure.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Nov 2022 19:11:47 -0800

postgis (3.3.1+dfsg-2) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 15 Oct 2022 21:45:26 +0200

postgis (3.3.1+dfsg-2~exp1) experimental; urgency=medium

  * Add metapackages to help upgrade the postgis packages.
  * Update packaging for postgresql-15.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 15 Oct 2022 08:03:48 +0200

postgis (3.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 10 Sep 2022 14:41:00 +0200

postgis (3.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 Aug 2022 15:08:10 +0200

postgis (3.3.0~rc2+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release candidate.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 23 Aug 2022 05:26:55 +0200

=== debian/control ===
Source: postgis
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Stephen Frost <sfrost@debian.org>,
           Francesco Paolo Lovergine <frankie@debian.org>,
           Markus Wanner <markus@bluegap.ch>,
           Bas Couwenberg <sebastic@debian.org>,
           Christoph Berg <myon@debian.org>
Section: misc
Priority: optional
Build-Depends: bison,
               dctrl-tools,
               dblatex,
               debhelper-compat (= 12),
               docbook,
               docbook-xsl,
               dpkg-dev (>= 1.16.1~),
               flex,
               imagemagick,
               libcunit1-dev,
               libgdal-dev (>= 1.11.2+dfsg-3~) | libgdal1-dev (>= 1.9.0~),
               libgeos-dev (>= 3.6),
               libjson-c-dev | libjson0-dev (>= 0.9~),
               libpcre2-dev,
               libproj-dev (>= 5.2.0),
               libprotobuf-c-dev,
               libsfcgal-dev (>= 1.3.1) [!armel !armhf],
               libxml2-dev (>= 2.5.0~),
               lsb-release,
               pkg-config,
               po-debconf,
               postgresql-all,
               postgresql-common (>= 148~),
               postgresql-server-dev-all,
               protobuf-c-compiler,
               rdfind,
               xsltproc
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/postgis
Vcs-Git: https://salsa.debian.org/debian-gis-team/postgis.git
Homepage: http://postgis.net/

Package: postgis
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: postgresql-postgis,
            postgis-doc
Description: Geographic objects support for PostgreSQL
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the PostGIS userland binaries for importing and
 exporting shape and raster files: pgsql2shp, raster2pgsql, and shp2pgsql.

Package: postgis-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: postgis
Description: Geographic objects support for PostgreSQL -- documentation
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the PostGIS documentation.

Package: postgresql-15-postgis-3
Architecture: any
Depends: postgresql-15,
         postgresql-15-postgis-3-scripts,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: postgis
Breaks: postgis (<< 1.2.1)
Provides: postgresql-15-postgis
Description: Geographic objects support for PostgreSQL 15
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".

Package: postgresql-15-postgis-3-scripts
Architecture: all
Multi-Arch: foreign
Depends: ${perl:Depends},
         ${misc:Depends}
Recommends: postgresql-15-postgis-3
Provides: postgresql-15-postgis-scripts
Replaces: postgresql-15-postgis-scripts (<< 2.2.2+dfsg-3~)
Description: Geographic objects support for PostgreSQL 15 -- SQL scripts
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the SQL scripts for installing PostGIS in a PostgreSQL
 15 database, and for upgrading from earlier PostGIS versions.

Package: postgresql-postgis
Architecture: any
Section: metapackages
Depends: postgresql-postgis-scripts,
         postgresql-15-postgis-3,
         ${misc:Depends}
Description: Geographic objects support for PostgreSQL -- Metapackage
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This metapackage depends on the PostGIS package for PostgreSQL 15.

Package: postgresql-postgis-scripts
Architecture: all
Multi-Arch: foreign
Depends: postgresql-15-postgis-3-scripts,
         ${misc:Depends}
Description: Geographic objects support for PostgreSQL -- SQL scripts metapackage
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This metapackage depends on the PostGIS scripts package for
 PostgreSQL 15.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifeq ($(DEB_HOST_ARCH), ppc64el)
    DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

# Don't fail when d/control doesn't match template
export PG_UPDATECONTROL=yes

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/postgresql-common/pgxs_debian_control.mk

# Upstream version (including ~rcN) for symbols version
UPSTREAM_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

MAJOR_VERSION = $(shell grep ^POSTGIS_MAJOR_VERSION Version.config | cut -d= -f2)
MINOR_VERSION = $(shell grep ^POSTGIS_MINOR_VERSION Version.config | cut -d= -f2)
MICRO_VERSION = $(shell grep ^POSTGIS_MICRO_VERSION Version.config | cut -d= -f2)
POSTGIS_VERSION = $(MAJOR_VERSION).$(MINOR_VERSION).$(MICRO_VERSION)
ifeq ($(POSTGIS_VERSION),..)
$(error Cannot detect Postgis version, fix debian/rules)
endif

# For the Postgres APT repository, we want to support multiple
# Postgres versions. However, docs and the JDBC jar only need to be
# built once - in the main directory.
NEWEST_POSTGRES_VERSION = $(shell pg_buildext supported-versions $(CURDIR) | tail -1)
ifeq ($(NEWEST_POSTGRES_VERSION),)
$(error Cannot detect Postgres version, check debian/pgversions and pg_buildext)
endif

OTHER_POSTGRES_VERSIONS = $(shell pg_buildext supported-versions $(CURDIR) \
	| grep -v "$(NEWEST_POSTGRES_VERSION)")

COMMON_CONFIGURE_ARGS = --host=$(DEB_HOST_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--exec-prefix=\$${prefix} \
	--docdir=\$${prefix}/share/doc \
	--mandir=\$${prefix}/share/man \
	--infodir=\$${prefix}/share/info \
	--without-interrupt-tests \
	--without-phony-revision \
	--enable-lto

NJOBS := -j1
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
NJOBS := -j$(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

%:
	dh $@

override_dh_autoreconf:
	dh_autoreconf ./autogen.sh

override_dh_auto_clean: debian/control
#	Clean all separate build directories.
	(set -ex; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		rm -rf $(CURDIR)/debian/build-$$PGVER; \
	done)

	[ ! -f GNUmakefile ] || $(MAKE) $(NJOBS) distclean || true
	[ ! -f GNUmakefile ] || $(MAKE) $(NJOBS) -C doc images-clean || true

#	Cleanup after the Makefile
	rm -f postgis/postgis_upgrade_20_minor.sql.in \
		raster/rt_pg/rtpostgis_drop.sql \
		raster/rt_pg/rtpostgis_upgrade_cleanup.sql

#	Cleanup auto-generated packaging control files
	rm -f $(CURDIR)/debian/postgresql-*-postgis-*.install
	rm -f $(CURDIR)/debian/postgresql-*-postgis-*.lintian-overrides
	rm -f $(CURDIR)/debian/postgresql-*-postgis-*-scripts.install
	rm -f $(CURDIR)/debian/postgresql-*-postgis-*-scripts.lintian-overrides
	rm -f $(CURDIR)/debian/postgresql-*-postgis-*-scripts.postinst
	rm -f $(CURDIR)/debian/postgresql-*-postgis-*-scripts.prerm
	rm -f loader/cunit/cu_tester
	rm -rf liblwgeom/cunit/.libs

override_dh_auto_configure:
#	Copy sources required to build extensions for all but the most
#	recent Postgres version. Unfortunately, Postgis doesn't support
#	vpath builds.
	(set -ex; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		mkdir $(CURDIR)/debian/build-$$PGVER; \
		for FILE in `ls $(CURDIR) | grep -v debian`; do \
			cp -a $$FILE $(CURDIR)/debian/build-$$PGVER; \
		done; \
	done)

#	PostGIS for the most recent PostgreSQL version
	@echo "### PostgreSQL $(NEWEST_POSTGRES_VERSION) configure ###"
	./configure $(COMMON_CONFIGURE_ARGS) \
		--datadir=\$${prefix}/share/postgresql-$(NEWEST_POSTGRES_VERSION)-postgis \
		--with-pgconfig=/usr/lib/postgresql/$(NEWEST_POSTGRES_VERSION)/bin/pg_config

#	PostGIS for all older Postgres versions
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		echo "### PostgreSQL $$PGVER configure ###"; \
		cd $(CURDIR)/debian/build-$$PGVER; \
		./configure $(COMMON_CONFIGURE_ARGS) \
			--datadir=\$${prefix}/share/postgresql-$$PGVER-postgis \
			--with-pgconfig=/usr/lib/postgresql/$$PGVER/bin/pg_config; \
	done)

override_dh_auto_build:
#	Create debhelper files for each Postgres major version
	(set -ex; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS) $(NEWEST_POSTGRES_VERSION); do \
		for SUFFIX in .install .lintian-overrides -scripts.install -scripts.lintian-overrides -scripts.postinst -scripts.prerm; do \
			cat $(CURDIR)/debian/postgresql-generic-postgis$$SUFFIX.in \
				| sed -e "s/@PGVERSION@/$$PGVER/g" \
				> $(CURDIR)/debian/postgresql-$$PGVER-postgis-$(MAJOR_VERSION)$$SUFFIX; \
		done \
	done)

#	Build against the newest Postgres version
	@echo "### PostgreSQL $(NEWEST_POSTGRES_VERSION) build ###"
	$(MAKE) $(NJOBS)
	$(MAKE) $(NJOBS) -C doc

#	Build against all other Postgres versions
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		echo "### PostgreSQL $$PGVER build ###"; \
		$(MAKE) $(NJOBS) -C $(CURDIR)/debian/build-$$PGVER; \
	done)

#	Let PostGIS create a perl script from postgis_restore.pl.in
	$(MAKE) $(NJOBS) -C utils

#	Create a few SQL scripts that the Makefiles are not clever enough
#	to resolve, when building arch-indep only.
	$(MAKE) $(NJOBS) -C postgis postgis.sql postgis_upgrade.sql
	$(MAKE) $(NJOBS) -C raster/rt_pg rtpostgis.sql rtpostgis_upgrade.sql
	$(MAKE) $(NJOBS) -C topology topology.sql topology_upgrade.sql

#	This creates the required SQL scripts. Again, the Makefile is not
#	clever enough to run this before 'install'.
	$(MAKE) $(NJOBS) -C extensions

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	Run unit tests (against the newest Postgres version first)
	@echo "### PostgreSQL $(NEWEST_POSTGRES_VERSION) test ###"
# Ignore test failure on problematic architectures
ifneq (,$(filter $(DEB_BUILD_ARCH),mips mips64el mipsel s390x alpha hppa hurd-i386 kfreebsd-i386 powerpc ppc64 sparc64))
	pg_virtualenv -v $(NEWEST_POSTGRES_VERSION) \
		make check RUNTESTFLAGS="-v" || echo "Ignoring test failures"
else
	pg_virtualenv -v $(NEWEST_POSTGRES_VERSION) \
		make check RUNTESTFLAGS="-v"
endif

#	Test against all other Postgres versions
ifneq (,$(filter $(DEB_BUILD_ARCH),mips mips64el mipsel s390x alpha hppa hurd-i386 kfreebsd-i386 powerpc ppc64 sparc64))
	set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		echo "### PostgreSQL $$PGVER test ###"; \
		pg_virtualenv -v $$PGVER \
			make -C $(CURDIR)/debian/build-$$PGVER check RUNTESTFLAGS="-v" || echo "Ignoring test failures"; \
	done
else
	set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		echo "### PostgreSQL $$PGVER test ###"; \
		pg_virtualenv -v $$PGVER \
			make -C $(CURDIR)/debian/build-$$PGVER check RUNTESTFLAGS="-v"; \
	done
endif
endif

override_dh_auto_install:
#	Install the most recent Postgres version. Note that we used to
#	install only utils and extensions. However, there are sql scripts
#	in postgis, raster and topology as well, which need to be
#	installed for the -scripts package(s).
	@echo "### PostgreSQL $(NEWEST_POSTGRES_VERSION) install ###"
	$(MAKE) $(NJOBS) install DESTDIR=$(CURDIR)/debian/tmp

#	Install all older Postgres versions.
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		echo "### PostgreSQL $$PGVER install ###"; \
		$(MAKE) $(NJOBS) -C $(CURDIR)/debian/build-$$PGVER \
			install DESTDIR=$(CURDIR)/debian/tmp; \
	done)

#	Remove unversioned and unused files from address standardizer
	rm -fv debian/tmp/usr/share/postgresql/*/extension/address_standardizer.sql
	rm -fv debian/tmp/usr/share/postgresql/*/extension/address_standardizer_data_us.sql

#	Move extension control files to version-specific names
#	(otherwise, the -script packages from different major versions would conflict)
	(set -ex; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS) $(NEWEST_POSTGRES_VERSION); do \
		for control in $(CURDIR)/debian/tmp/usr/share/postgresql/$$PGVER/extension/*.control; do \

## postgis 3.3.3+dfsg

=== debian/changelog ===
postgis (3.3.3+dfsg-2ubuntu1) mantic; urgency=medium

  * Merge with Debian unstable. Remaining change:
    - Disable LTO on ppc64el to fix build failure.

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 27 Jun 2023 14:29:30 -0400

postgis (3.3.3+dfsg-2) unstable; urgency=medium

  * Bump debhelper compat to 13.
  * Add patch to fix FTBFS with PROJ 9.2.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 13 Jun 2023 21:01:54 +0200

postgis (3.3.3+dfsg-1) unstable; urgency=medium

  * Ignore autopkgtest failure on armel/armhf, sfcgal not available there.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 11 Jun 2023 11:59:00 +0200

postgis (3.3.3+dfsg-1~exp1) experimental; urgency=medium

  [ Christoph Berg ]
  * Refactor "ignore tests on some architectures" code.
  * Sync architectures to skip between debian/rules and debian/tests,
    effectively re-enabling tests on arm*.
  * Remove obsolete Breaks and Replaces.

  [ Bas Couwenberg ]
  * New upstream release.
  * Add Rules-Requires-Root to control file.
  * Bump Standards-Version to 4.6.2, no changes.
  * Update URLs to use HTTPS.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 30 May 2023 05:36:20 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Build-Depends: bison,
                dctrl-tools,
                dblatex,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                docbook,
                docbook-xsl,
                dpkg-dev (>= 1.16.1~),
@@ -35,10 +35,11 @@
                protobuf-c-compiler,
                rdfind,
                xsltproc
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/postgis
 Vcs-Git: https://salsa.debian.org/debian-gis-team/postgis.git
-Homepage: http://postgis.net/
+Homepage: https://postgis.net/
+Rules-Requires-Root: no
 
 Package: postgis
 Architecture: any
@@ -80,7 +81,6 @@
          ${shlibs:Depends},
          ${misc:Depends}
 Suggests: postgis
-Breaks: postgis (<< 1.2.1)
 Provides: postgresql-15-postgis
 Description: Geographic objects support for PostgreSQL 15
  PostGIS adds support for geographic objects to the PostgreSQL
@@ -97,7 +97,6 @@
          ${misc:Depends}
 Recommends: postgresql-15-postgis-3
 Provides: postgresql-15-postgis-scripts
-Replaces: postgresql-15-postgis-scripts (<< 2.2.2+dfsg-3~)
 Description: Geographic objects support for PostgreSQL 15 -- SQL scripts
  PostGIS adds support for geographic objects to the PostgreSQL
  object-relational database. In effect, PostGIS "spatially enables"

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 ifeq ($(DEB_HOST_ARCH), ppc64el)
-    DEB_BUILD_MAINT_OPTIONS += optimize=-lto
+	DEB_BUILD_MAINT_OPTIONS += optimize=-lto
 endif
 
 # Don't fail when d/control doesn't match template
@@ -20,6 +20,14 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 include /usr/share/postgresql-common/pgxs_debian_control.mk
+
+# Ignore testsuite failures on these architectures
+IGNORE_TEST_FAILURE_ARCHS = mips mips64el mipsel s390x alpha hppa hurd-i386 kfreebsd-i386 powerpc ppc64 sparc64
+ifneq (,$(filter $(DEB_BUILD_ARCH),$(IGNORE_TEST_FAILURE_ARCHS)))
+	TEST_FAIL_COMMAND = echo "Ignoring test failures"
+else
+	TEST_FAIL_COMMAND = exit 1
+endif
 
 # Upstream version (including ~rcN) for symbols version
 UPSTREAM_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
@@ -158,31 +166,16 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 #	Run unit tests (against the newest Postgres version first)
 	@echo "### PostgreSQL $(NEWEST_POSTGRES_VERSION) test ###"
-# Ignore test failure on problematic architectures
-ifneq (,$(filter $(DEB_BUILD_ARCH),mips mips64el mipsel s390x alpha hppa hurd-i386 kfreebsd-i386 powerpc ppc64 sparc64))
 	pg_virtualenv -v $(NEWEST_POSTGRES_VERSION) \
-		make check RUNTESTFLAGS="-v" || echo "Ignoring test failures"
-else
-	pg_virtualenv -v $(NEWEST_POSTGRES_VERSION) \
-		make check RUNTESTFLAGS="-v"
-endif
+		make check RUNTESTFLAGS="-v" || $(TEST_FAIL_COMMAND)
 
 #	Test against all other Postgres versions
-ifneq (,$(filter $(DEB_BUILD_ARCH),mips mips64el mipsel s390x alpha hppa hurd-i386 kfreebsd-i386 powerpc ppc64 sparc64))
 	set -e; \
 	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
 		echo "### PostgreSQL $$PGVER test ###"; \
 		pg_virtualenv -v $$PGVER \
-			make -C $(CURDIR)/debian/build-$$PGVER check RUNTESTFLAGS="-v" || echo "Ignoring test failures"; \
+			make -C $(CURDIR)/debian/build-$$PGVER check RUNTESTFLAGS="-v" || $(TEST_FAIL_COMMAND); \
 	done
-else
-	set -e; \
-	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
-		echo "### PostgreSQL $$PGVER test ###"; \
-		pg_virtualenv -v $$PGVER \
-			make -C $(CURDIR)/debian/build-$$PGVER check RUNTESTFLAGS="-v"; \
-	done
-endif
 endif
 
 override_dh_auto_install:
@@ -210,3 +203,14 @@
 	(set -ex; \
 	for PGVER in $(OTHER_POSTGRES_VERSIONS) $(NEWEST_POSTGRES_VERSION); do \
 		for control in $(CURDIR)/debian/tmp/usr/share/postgresql/$$PGVER/extension/*.control; do \
+			mv $$control $${control%.control}-$(MAJOR_VERSION).control; \
+		done \
+	done)
+
+#	Compile and install docs
+	$(MAKE) -C doc docs-install man-install \
+		DESTDIR=$(CURDIR)/debian/tmp \
+		PGSQL_DOCDIR=/usr/share/doc \
+		PGSQL_MANDIR=/usr/share/man
+
+#	Move binaries from the NEWEST_POSTGRES_VERSION build to the

## postgis 3.3.4+dfsg

=== debian/changelog ===
postgis (3.3.4+dfsg-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.
    + Disable proj-7.0.1.patch.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Fri, 28 Jul 2023 14:40:16 +0200

postgis (3.3.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop PROJ 9.2 & GEOS 3.12 patches, fixed upstream.
    Drop powerpc patch, applied upstream.
    Refresh remaining patches.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Jul 2023 14:40:16 +0200

postgis (3.3.3+dfsg-5) unstable; urgency=medium

  * Fix --enable-lto configure option.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 27 Jul 2023 10:02:30 +0200

postgis (3.3.3+dfsg-4) unstable; urgency=medium

  * Add graphicsmagick-imagemagick-compat to Build-Conflicts.
    https://trac.osgeo.org/postgis/ticket/5446
  * Ignore test failure on i386.
    https://trac.osgeo.org/postgis/ticket/5448
  * Add patch to fix FTBFS on powerpc architectures.
    https://trac.osgeo.org/postgis/ticket/5450

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 27 Jul 2023 09:45:35 +0200

postgis (3.3.3+dfsg-3) unstable; urgency=medium

  * Add patch to fix FTBFS with GEOS 3.12.
    (closes: #1042263)

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 27 Jul 2023 07:09:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: postgis
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Stephen Frost <sfrost@debian.org>,
            Francesco Paolo Lovergine <frankie@debian.org>,
            Markus Wanner <markus@bluegap.ch>,
@@ -11,7 +10,7 @@
 Build-Depends: bison,
                dctrl-tools,
                dblatex,
-               debhelper-compat (= 13),
+               debhelper (>= 12),
                docbook,
                docbook-xsl,
                dpkg-dev (>= 1.16.1~),
@@ -35,6 +34,7 @@
                protobuf-c-compiler,
                rdfind,
                xsltproc
+Build-Conflicts: graphicsmagick-imagemagick-compat
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/postgis
 Vcs-Git: https://salsa.debian.org/debian-gis-team/postgis.git
@@ -74,6 +74,70 @@
  .
  This package contains the PostGIS documentation.
 
+Package: postgresql-11-postgis-3
+Architecture: any
+Depends: postgresql-11,
+         postgresql-11-postgis-3-scripts,
+         ${shlibs:Depends},
+         ${misc:Depends}
+Suggests: postgis
+Provides: postgresql-11-postgis
+Description: Geographic objects support for PostgreSQL 11
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+
+Package: postgresql-12-postgis-3
+Architecture: any
+Depends: postgresql-12,
+         postgresql-12-postgis-3-scripts,
+         ${shlibs:Depends},
+         ${misc:Depends}
+Suggests: postgis
+Provides: postgresql-12-postgis
+Description: Geographic objects support for PostgreSQL 12
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+
+Package: postgresql-13-postgis-3
+Architecture: any
+Depends: postgresql-13,
+         postgresql-13-postgis-3-scripts,
+         ${shlibs:Depends},
+         ${misc:Depends}
+Suggests: postgis
+Provides: postgresql-13-postgis
+Description: Geographic objects support for PostgreSQL 13
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+
+Package: postgresql-14-postgis-3
+Architecture: any
+Depends: postgresql-14,
+         postgresql-14-postgis-3-scripts,
+         ${shlibs:Depends},
+         ${misc:Depends}
+Suggests: postgis
+Provides: postgresql-14-postgis
+Description: Geographic objects support for PostgreSQL 14
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+
 Package: postgresql-15-postgis-3
 Architecture: any
 Depends: postgresql-15,
@@ -89,6 +153,78 @@
  database for geographic information systems (GIS), much like ESRI's
  SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
  "Simple Features Specification for SQL".
+
+Package: postgresql-11-postgis-3-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${perl:Depends},
+         ${misc:Depends}
+Recommends: postgresql-11-postgis-3
+Provides: postgresql-11-postgis-scripts
+Description: Geographic objects support for PostgreSQL 11 -- SQL scripts
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+ .
+ This package contains the SQL scripts for installing PostGIS in a PostgreSQL
+ 11 database, and for upgrading from earlier PostGIS versions.
+
+Package: postgresql-12-postgis-3-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${perl:Depends},
+         ${misc:Depends}
+Recommends: postgresql-12-postgis-3
+Provides: postgresql-12-postgis-scripts
+Description: Geographic objects support for PostgreSQL 12 -- SQL scripts
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+ .
+ This package contains the SQL scripts for installing PostGIS in a PostgreSQL
+ 12 database, and for upgrading from earlier PostGIS versions.
+
+Package: postgresql-13-postgis-3-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${perl:Depends},
+         ${misc:Depends}
+Recommends: postgresql-13-postgis-3
+Provides: postgresql-13-postgis-scripts
+Description: Geographic objects support for PostgreSQL 13 -- SQL scripts
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+ .
+ This package contains the SQL scripts for installing PostGIS in a PostgreSQL
+ 13 database, and for upgrading from earlier PostGIS versions.
+
+Package: postgresql-14-postgis-3-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${perl:Depends},
+         ${misc:Depends}
+Recommends: postgresql-14-postgis-3
+Provides: postgresql-14-postgis-scripts
+Description: Geographic objects support for PostgreSQL 14 -- SQL scripts
+ PostGIS adds support for geographic objects to the PostgreSQL
+ object-relational database. In effect, PostGIS "spatially enables"
+ the PostgreSQL server, allowing it to be used as a backend spatial
+ database for geographic information systems (GIS), much like ESRI's
+ SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
+ "Simple Features Specification for SQL".
+ .
+ This package contains the SQL scripts for installing PostGIS in a PostgreSQL
+ 14 database, and for upgrading from earlier PostGIS versions.
 
 Package: postgresql-15-postgis-3-scripts
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -9,10 +9,6 @@
 
 # Enable hardening build flags
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
-
-ifeq ($(DEB_HOST_ARCH), ppc64el)
-	DEB_BUILD_MAINT_OPTIONS += optimize=-lto
-endif
 
 # Don't fail when d/control doesn't match template
 export PG_UPDATECONTROL=yes
@@ -22,7 +18,7 @@
 include /usr/share/postgresql-common/pgxs_debian_control.mk
 
 # Ignore testsuite failures on these architectures
-IGNORE_TEST_FAILURE_ARCHS = mips mips64el mipsel s390x alpha hppa hurd-i386 kfreebsd-i386 powerpc ppc64 sparc64
+IGNORE_TEST_FAILURE_ARCHS = i386 mips mips64el mipsel s390x alpha hppa hurd-i386 kfreebsd-i386 powerpc ppc64 sparc64
 ifneq (,$(filter $(DEB_BUILD_ARCH),$(IGNORE_TEST_FAILURE_ARCHS)))
 	TEST_FAIL_COMMAND = echo "Ignoring test failures"
 else
@@ -214,3 +210,5 @@
 		PGSQL_MANDIR=/usr/share/man
 
 #	Move binaries from the NEWEST_POSTGRES_VERSION build to the
+#	'postgis' binary package.
+	mkdir -p $(CURDIR)/debian/postgis/usr/bin

## postgis 3.4.2%2Bdfsg

=== extensions/address_standardizer/Makefile ===
include ./../upgradeable_versions.mk
OBJS = \
    address_parser.o \
    address_standardizer.o \
    std_pg_hash.o \
    analyze.o \
    err_param.o \
    export.o \
    gamma.o \
    hash.o \
    lexicon.o \
    pagc_tools.o \
    parseaddress-api.o \
    standard.o \
    tokenize.o

OBJS_test_main = \
    test_main.o \
    analyze.o \
    err_param.o \
    export.o \
    gamma.o \
    hash.o \
    lexicon.o \
    pagc_tools.o \
    standard.o \
    tokenize.o

POSTGIS_PGSQL_VERSION=130
# SQL preprocessor
SQLPP = /usr/bin/cpp -traditional-cpp -w -P -Upixel -Ubool
GREP=/bin/grep
EXTVERSION = 3.4.2
MODULE_big = address_standardizer-3
MODULEPATH    = $$libdir/address_standardizer-3
ifeq (no,yes)
MODULE_big = address_standardizer-3.4
MODULEPATH    = $$libdir/address_standardizer-3.4
endif
EXTENSION = address_standardizer
EXTENSION_SCRIPTS = \
 		sql/address_standardizer_types.sql \
    sql/address_standardizer_functions.sql

DATA_built = \
	$(EXTENSION).control \
	$(EXTENSION)_data_us.control \
	$(NULL)

all:  sql/address_standardizer_pre.sql sql/address_standardizer.sql sql/address_standardizer--1.0--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--ANY--$(EXTVERSION).sql \
 sql/$(EXTENSION)_data_us.sql sql/address_standardizer--3.4.2.sql sql/$(EXTENSION)_data_us--3.4.2.sql  sql/$(EXTENSION)_data_us--$(EXTVERSION)--$(EXTVERSION)next.sql \
sql/$(EXTENSION)_data_us--$(EXTVERSION)next--$(EXTVERSION).sql sql/$(EXTENSION)_data_us--ANY--$(EXTVERSION).sql \
sql/test-init-extensions.sql sql/test-parseaddress.sql sql/test-standardize_address_1.sql sql/test-standardize_address_2.sql sql/test-debug_standardize_address.sql

DOCS = README.address_standardizer
PG_CPPFLAGS = -std=gnu99 -g -O2 -fno-math-errno -fno-signed-zeros -Wall  -I/var/lib/jenkins/workspace/geos/rel-3.10w64/include   -I/usr/include/libxml2 -I/usr/include -I/usr/include/json-c  -DNDEBUG  -DPCRE_VERSION=0

SHLIB_LINK =  -L/var/lib/jenkins/workspace/geos/rel-3.10w64/lib -lgeos_c -lproj -ljson-c -lprotobuf-c -lxml2 -L/usr/lib/x86_64-linux-gnu -lSFCGAL -lgmpxx -Wl,--exclude-libs,ALL  -lm 
EXTRA_CLEAN = sql/ usps-st-city-name.txt mk-st-regexp mk-city-regex test_main
REGRESS = test-init-extensions test-parseaddress test-standardize_address_1 test-standardize_address_2 test-debug_standardize_address

sql:
	mkdir -p $@

# Borrow the $libdir substitution from PGXS but customise by running the preprocessor
# and adding the version number
sql/%.sql: %.sql.in | sql
	$(SQLPP) -I@buiddir@/../libpgcommon $< > $@.tmp
	grep -v '^#' $@.tmp | \
	$(PERL) -lpe "s'MODULE_PATHNAME'\$(MODULEPATH)'g" > $@
	rm -f $@.tmp

%.control: %.control.in Makefile
	cat $< \
		| $(PERL) -lpe "s'@EXTVERSION@'$(EXTVERSION)'g" \
		> $@

sql/address_standardizer_pre.sql: $(EXTENSION_SCRIPTS) | sql
	cat $^ > $@

sql/address_standardizer--$(EXTVERSION).sql: sql/address_standardizer_pre.sql ../../utils/create_or_replace_to_create.pl | sql
	cat $< \
		| $(PERL) ../../utils/create_or_replace_to_create.pl sql/address_standardizer_pre.sql \
		> $@

sql/address_standardizer.sql: sql/address_standardizer_pre.sql ../../utils/create_or_replace_to_create.pl | sql
	cat $< \
		| $(PERL) ../../utils/create_or_replace_to_create.pl sql/address_standardizer_pre.sql \
		> $@

EXTENSION_UPGRADE_SCRIPTS = sql/address_standardizer_functions.sql

# upgrade logic for us data extension (to go to original round-robin yoyo cludge for dev upgrading)
sql/$(EXTENSION)--1.0--$(EXTVERSION).sql: sql/address_standardizer_functions.sql | sql
	cat $^ > $@

sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql/address_standardizer_functions.sql | sql
	cat $^ > $@

# build us data extension
sql/$(EXTENSION)_data_us--$(EXTVERSION).sql: us_lex.sql us_gaz.sql us_rules.sql sql_bits/address_standardizer_data_us_mark_editable_objects.sql.in | sql
	cat $^ > $@

sql/$(EXTENSION)_data_us.sql: us_lex.sql us_gaz.sql us_rules.sql sql_bits/address_standardizer_data_us_mark_editable_objects.sql.in | sql
	cat $^ > $@

# upgrade logic for us data extension (to go to next cludge for dev upgrading)
sql/$(EXTENSION)_data_us--$(EXTVERSION)--$(EXTVERSION)next.sql: sql/$(EXTENSION)_data_us--$(EXTVERSION).sql | sql
	cat $^ > $@

# upgrade logic for us data extension (to go to original round-robin yoyo cludge for dev upgrading)
sql/$(EXTENSION)_data_us--$(EXTVERSION)next--$(EXTVERSION).sql: sql/$(EXTENSION)_data_us--$(EXTVERSION).sql | sql
	cat $^ > $@


sql/$(EXTENSION)--ANY--$(EXTVERSION).sql: $(EXTENSION_UPGRADE_SCRIPTS)
	cat $(EXTENSION_UPGRADE_SCRIPTS) > $@

sql/$(EXTENSION)_data_us--ANY--$(EXTVERSION).sql: sql/$(EXTENSION)_data_us--$(EXTVERSION).sql | sql
	cat $^ > $@

include ./../upgrade-paths-rules.mk

# TODO: fix this by moving data in their own directories
ifeq ($(EXTENSION_DATA_INSTALL),)
LANGUAGES = us
install-upgrade-paths: install-upgrade-paths-data
install-extension-upgrades-from-known-versions: install-extension-upgrades-from-known-versions-data
install-upgrade-paths-data install-extension-upgrades-from-known-versions-data:
	TARGET=`echo $@ | sed 's/-data$$//'`; \
	for lang in $(LANGUAGES); do \
		EXTENSION_DATA_INSTALL=1 \
		$(MAKE) $${TARGET} \
		EXTENSION=$(EXTENSION)_data_$${lang} \
		|| exit 1; \
	done
endif

mk-st-regexp: mk-st-regexp.pl
	$(PERL) -c mk-st-regexp.pl
	rm -f mk-st-regexp
	echo "#! " $(PERL) > mk-st-regexp
	cat mk-st-regexp.pl >> mk-st-regexp
	chmod ugo+x mk-st-regexp

mk-city-regex: mk-city-regex.pl usps-st-city-name.txt
	$(PERL) -c mk-city-regex.pl
	rm -f mk-city-regex
	echo "#! " $(PERL) > mk-city-regex
	cat mk-city-regex.pl >> mk-city-regex
	chmod ugo+x mk-city-regex

usps-st-city-name.txt: usps-st-city-orig.txt usps-st-city-adds.txt
	cat usps-st-city-orig.txt usps-st-city-adds.txt | sort -u >usps-st-city-name.txt

#parseaddress-stcities.h: mk-city-regex
#	./mk-city-regex > parseaddress-stcities.h

#parseaddress-regex.h: mk-st-regexp
#	./mk-st-regexp > parseaddress-regex.h

dist-clean:
	rm -f mk-st-regexp mk-city-regex usps-st-city-name.txt test_main Makefile


test_main: $(OBJS_test_main)
	gcc -o test_main $(OBJS_test_main) $(LDFLAGS) $(LIBS)

test_main.o: test_main.c pagc_api.h pagc_std_api.h

address_parser.o: address_parser.c parseaddress-api.h

address_standardizer.o: address_standardizer.c std_pg_hash.h pagc_api.h pagc_std_api.h

analyze.o: analyze.c pagc_api.h

err_param.o: err_param.c pagc_api.h

export.o: export.c pagc_api.h pagc_tools.h

gamma.o: gamma.c pagc_api.h pagc_std_api.h gamma.h

hash.o: hash.c hash.h khash.h

lexicon.o: lexicon.c pagc_api.h pagc_std_api.h

pagc_tools.o: pagc_tools.c pagc_tools.h pagc_common.h

parseaddress-api.o: parseaddress-api.c parseaddress-api.h parseaddress-stcities.h parseaddress-regex.h

standard.o: standard.c pagc_api.h

tokenize.o: tokenize.c pagc_api.h

std_pg_hash.o: std_pg_hash.c std_pg_hash.h pagc_api.h pagc_std_api.h

#only extension files
DATA_built += $(wildcard sql/*--*.sql)
EXTRA_CLEAN += $(wildcard expected/*--*.out)
EXTRA_CLEAN += *.a *.so *.dll

distclean: clean
	rm Makefile

PG_CONFIG := /var/lib/jenkins/workspace/pg/rel/pg13w64/bin/pg_config
PGXS := /var/lib/jenkins/workspace/pg/rel/pg13w64/lib/postgresql/pgxs/src/makefiles/pgxs.mk
include $(PGXS)
PERL = /usr/bin/perl
ifneq (/bin/mkdir -p,)
	MKDIR_P = /bin/mkdir -p
endif

srcdir = .
top_srcdir = ../..
abs_topbuilddir=$(abspath $(top_builddir))

# Overriding top_builddir breaks the "installcheck"
# target from PGXS. TODO: integrate regression tests
# with the rest of the application
#top_builddir = ../..



INSTALLED_UPGRADE_SCRIPTS +=  \
	$(wildcard $(EXTDIR)/$(EXTENSION)_data_us--*--$(EXTVERSION).sql) \
	$(wildcard $(EXTDIR)/$(EXTENSION)_data_us--*--ANY.sql) \
	$(NULL)

install: all installdirs
	$(INSTALL_DATA) $(addprefix $(srcdir)/, $(DATA)) $(DATA_built) '$(DESTDIR)$(datadir)/$(datamoduledir)/'
ifdef DOCS
ifdef docdir
	$(INSTALL_DATA) $(addprefix $(srcdir)/, $(DOCS)) '$(DESTDIR)$(docdir)/$(docmoduledir)/'
endif # docdir
endif # DOCS
ifdef MODULE_big
ifeq ($(with_llvm), yes)
	$(call install_llvm_module,$(MODULE_big),$(OBJS))
endif # with_llvm
install: install-lib
endif # MODULE_big
